/* Given variables A and B, each holding an 8-bit signed 2's complement number, 
 * write a program to find the maximum value and put into variable C. For 
 * example if A > B then C = A.
 *
 * Solution A: Basic implementation of if-then-else statement
 * using load -> do something -> store structure
 */ 
.INCLUDE <m328pdef.inc> 

.DSEG
A:     .BYTE 1
B:     .BYTE 1
C:     .BYTE 1

.CSEG
Max1:
	lds  r16,A    ; load
	lds  r17,B
	cp   r16,r17
	brlt elseMax1 ; if (A >= B)  note: if A < B branch to else block
	mov  r18,r16  ; then C = A
	rjmp endMax1
elseMax1: 
    mov  r18,r17
	sts  C,r18    ; store
endMax1:
    rjmp Max1
